#include "app_timer.h"

void TIMER_B0_init()
{
    Timer_B_initContinuousModeParam initContParam = {0};
    
    //Start timer in continuous mode sourced by ACLK
    initContParam.clockSource = TIMER_B_CLOCKSOURCE_ACLK;
    initContParam.clockSourceDivider = TIMER_B_CLOCKSOURCE_DIVIDER_64;
    initContParam.timerInterruptEnable_TBIE = TIMER_B_TBIE_INTERRUPT_DISABLE;
    initContParam.timerClear = TIMER_B_DO_CLEAR;
    initContParam.startTimer = true;
    Timer_B_initContinuousMode(TIMER_B0_BASE, &initContParam);
    
    /*TIMER_B0_RN_start(TIMER_B_CAPTURECOMPARE_REGISTER_0, 10000);
    Timer_B_startCounter( TIMER_B0_BASE, TIMER_B_CONTINUOUS_MODE);*/
}

/*timeout, ms*/
void TIMER_B0_RN_start(uint16_t captureCompareRegister, uint16_t timeout)
{
    /*
    Timer_B_clearCaptureCompareInterrupt(TIMER_B0_BASE, captureCompareRegister);
    
    Timer_B_initCompareModeParam initCompParam = {0};
    initCompParam.compareRegister = captureCompareRegister;
    initCompParam.compareInterruptEnable = TIMER_B_CAPTURECOMPARE_INTERRUPT_ENABLE;
    initCompParam.compareOutputMode = TIMER_B_OUTPUTMODE_OUTBITVALUE;
    
    Timer_B_clearCaptureCompareInterrupt(TIMER_B0_BASE, captureCompareRegister);
    Timer_B_enableCaptureCompareInterrupt(TIMER_B0_BASE, captureCompareRegister);
    
    uint16_t compVal = Timer_B_getCounterValue(TIMER_B0_BASE) + (uint16_t)(TBPERIOODCOUNT/1000.0*timeout);
    initCompParam.compareValue = compVal;
    
    Timer_B_initCompareMode(TIMER_B0_BASE, &initCompParam);*/
    
    Timer_B_clearCaptureCompareInterrupt(TIMER_B0_BASE, captureCompareRegister);
    Timer_B_enableCaptureCompareInterrupt(TIMER_B0_BASE, captureCompareRegister);
    
    uint16_t compVal = Timer_B_getCounterValue(TIMER_B0_BASE) + (uint16_t)(TBPERIOODCOUNT/1000.0*timeout);
    Timer_B_setCompareValue(TIMER_B0_BASE, captureCompareRegister, compVal);
}

void TIMER_B0_RN_stop(uint16_t captureCompareRegister)
{
    Timer_B_clearCaptureCompareInterrupt(TIMER_B0_BASE, captureCompareRegister);
    Timer_B_disableCaptureCompareInterrupt(TIMER_B0_BASE, captureCompareRegister);
}

void TIMER_B0_RN_reload(uint16_t captureCompareRegister, uint16_t timeout)
{
    Timer_B_clearCaptureCompareInterrupt(TIMER_B0_BASE, captureCompareRegister);
    uint16_t compVal = Timer_B_getCounterValue(TIMER_B0_BASE) + (uint16_t)(TBPERIOODCOUNT/1000.0*timeout);
    Timer_B_setCompareValue(TIMER_B0_BASE, captureCompareRegister, compVal);
}

#pragma vector=TIMER0_B0_VECTOR
__interrupt void TIMER0_B0_ISR (void)
{
    WDT_A_start(WDT_A_BASE);
    switch(systemstate.mainpro)
    {
    case MAIN_PROCESS_IDLE:
        break;
        
    case MAIN_PROCESS_JOININ:
        TIMER_B0_RN_stop(MAIN_TIMER_REGISTER);
        do_send();
        break;
        
    case MAIN_PROCESS_DATAUP_FIRST:
        TIMER_B0_RN_reload(MAIN_TIMER_REGISTER, configinfo_time.period*60000);
        do_send();
    break;
    
    case MAIN_PROCESS_DATAUP_SECOND:
    break;
    
    default:
    break;
    }
    WDT_A_resetTimer(WDT_A_BASE);
    WDT_A_hold(WDT_A_BASE);
}
